\ignore{
\begin{code}
{-#LANGUAGE BangPatterns,DeriveGeneric#-}
\end{code}
}
\begin{code}
module Tile where
import Data.Bits
import qualified Data.Vector.Unboxed as U
import qualified Data.Vector as V
import Data.Binary
import Data.Vector.Binary()
import GHC.Generics
type Tile=Int

wgl,mgl::Int
wgl=5
mgl=(1`shiftL`wgl)-1

north,south,east,west,color::Tile->Int
south (!t)=let !x=t`shiftR`(wgl*4) in x
west ( !t)=let !x=(t`shiftR`(wgl*3)) .&. mgl in x
north ( !t)=let !x=(t`shiftR`(wgl*2)) .&. mgl in x
east ( !t)=let !x=(t`shiftR`(wgl)) .&. mgl in x
color ( !t)=let !x=t.&.mgl in x

withN,withS,withE,withW,withC::Tile->Int->Tile
withS ( !t) !x=(t.&.(complement $ mgl`shiftL`(wgl*4))) .|. (x`shiftL`(wgl*4))
withW ( !t) !x=(t.&.(complement $ mgl`shiftL`(wgl*3))) .|. (x`shiftL`(wgl*3))
withN ( !t) !x=(t.&.(complement $ mgl`shiftL`(wgl*2))) .|. (x`shiftL`(wgl*2))
withE ( !t) !x=(t.&.(complement $ mgl`shiftL`wgl)) .|. (x`shiftL`wgl)
withC ( !t) !x=(t.&.(complement $ mgl)) .|. x


data Job=J {
  tileset::U.Vector Int,
  assembly::V.Vector (U.Vector Int),
  posX::Int,
  posY::Int,
  k::Int
  }
        | R { tileset::U.Vector Int,
              assembly::V.Vector (U.Vector Int) }
        deriving (Generic,Ord,Eq,Show)

instance Binary Job

pattern::V.Vector (U.Vector Int)
pattern=
  V.fromList $
  map (\row->U.fromList $ map (\x->if x=='0' then 0 else 1) row) $
  [
    "101101110111111011111",
    "000000000000000000000",
    "011110101101101111011",
    "110111011011111101111",
    "000000000000000000000",
    "011110101101101111011",
    "110111111011111101111",
    "011110101101101111011",
    "110111111011111101111",
    "000000000000000000000",
    "011110101101101111011",
    "110111111011111101111",
    "011110101101101111011",
    "110111111011111101111",
    "000000000000000000000",
    "011110101101101111011",
    "101011111110111110111",
    "000000000000000000000",
    "011110101101101111011",
    "110101111111011111101",
    "000000000000000000000",
    "011110101101101111011",
    "110101111111011111111"
  ]
\end{code}
